<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
	<head>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
	<title>fil rss : exemple de lecture</title>
		<style type="text/css" media="screen"><!--
.cadre  { float: none; margin-right: auto; margin-left: auto; padding: 3px; border: solid 1px #696969; width: 75% }
--></style>
	</head>
<body>

<?php
// ---------------------------------------------------------
// rss_read - classe pour lire des fichiers RSS/RDF/Atom
// Dominique WOJYLAC <http://wojylac.free.fr>
// Distribu sous GNU General Public License.
// 
// Version 2.0
// ---------------------------------------------------------

// fonction de nettoyage du texte rcupr

function clean_text($text, $encodage = '') {
	$text = str_replace('&lt;','<',$text);
	$text = str_replace('&gt;','>',$text);
	$text = str_replace('&quot;','"',$text);
	$text = str_replace('&amp;','&',$text);
	/* pour supprimer les images */
	/* $text = preg_replace("'<img.*?>'si",'',$text); */
	// pour le traitement suivant encodage du fil
	if ($encodage == 'utf-8') {
		$text = utf8_decode($text);
	}
	return $text;
}

// traite les dates au format
// '2004-06-07T11:13:19+01:00'
// ou 'Sun, 26 Jun 2005 10:16:26 GMT'
function clean_date($date) 
{
	// si 'AAAA-MM-JJTHH:MM:SS+00:00' ou 'AAAA-MM-JJTHH:MM:SSZ'
    if (ereg("^[0-9]",$date) and  ereg("(([[:digit:]]|-)*)T(([[:digit:]]|:)*)[^[:digit:]].*",$date,$temp)) {
		$date = $temp[1].' '.$temp[3];
	}
	// affichage au format franais
	setlocale(LC_TIME, 'fr_FR');
	// rgler ici le format d'affichage des dates
	$date = strftime("%A %d %B %Y  %Hh", strtotime($date));
	return $date;	
}

// la classe rss_read
include 'rss_read.inc.php';

// crer l'instance
$rss = new rss_read();

// caractres parasites pouvant tre contenus dans le fils rss et  remplacer par d'autres
// doit tre invoqu avant parsefile
// cette fonction est optionnelle et ne doit tre utilise que pour certains fils.
$avant = array('&#8217;','&bull;');
$apres = array("'",'-');
$rss -> to_replace_with($avant, $apres);

// parser le fichier news avec ventuellement un nbre max
// parser = mettre toutes les infos dans les tableaux associatifs ruprs plus bas

// quelques fils divers, choix non exhaustif
// $flux = 'http://www.arteradio.com/servlet/RSSMakerServlet';
// $flux = 'http://www.annonay.org/agenda.rss';
// $flux = 'http://rezo.net/backend/portail';
// $flux = 'http://www.macbidouille.com/macbidouille.rss';
$flux = 'http://www.zdnet.fr/feeds/rss/actualites/';
// $flux = 'http://www.liberation.fr/rss.php';
// $flux = 'http://www.gete.net/mac/backend.php3';
// format atom
// $flux = 'http://www.macdigit.com/index.php/weblog/rss_atom';
// $flux = 'http://ledroitpourlajustice.blogspirit.com/atom.xml';

$res = $rss -> parsefile($flux);
// ou $res = $rss -> curl_parsefile($flux);

if ($res === false) {
	exit('Fichier rss incorrect ou erreur pendant l\'analyse !');
}

// recupration de l'encodage du fil iso ou utf
// vide si celui-ci n'est pas indiqu
$encode = $rss -> get_encoding();

// on affiche les infos dans un cadre centr mis en forme par le style interne .cadre
echo '<div class="cadre">';
// on aurait pu aussi mettre un tableau
// echo '<table align="center" border="1" width="75%" cellspacing="0" cellpadding="3"><tr><td>';

// informations fil, encodage, last_modified
$date_modif = $rss -> get_last_modified($flux, false);
// $date_modif = $rss -> curl_get_last_modified($flux, false);

echo '<p><i>Flux : ',$flux, '<br />Encodage : ', $encode, '<br /> Date modification : ', $date_modif, '</i></p>';
// recupration des donnes sur le channel
$channel = $rss -> get_channel();

echo '<p align="center"><b><a href="', $channel['link'],'">', clean_text($channel['title'],$encode), '</a><br />', clean_text($channel['description'],$encode), '</b></p>';

if ($rss -> exist_image()) {
	$image = $rss -> get_image();
	$img =  '<div align="center">';
	if (!empty($image['link'])) {
		$img .= '<a href="'.$image['link'].'">';
	} else {
		$img .= '<a href="'.$channel['link'].'">';
	}
	$img .= '<img src="'.$image['url'].'"';
	
	if (!empty($image['width'])) {
		$img .= ' width="'.$image['width'].'"';
	}
	
	if (!empty($image['height'])) {
		$img .= ' height="'.$image['height'].'"';
	}
	
	if (!empty($image['title'])) {
		$title = clean_text($image['title'], $encode);
	} else {
		$title = clean_text($channel['title'], $encode);
	} 
	
	$img .= 'border="0" alt="'.$title.'"></a></div>';
	echo $img."\n";
}


// nombre d'items     
$nbnews = $rss -> get_num_items();

// recup array des donnes
$items = $rss -> get_items();

for($i = 0; $i < $nbnews; $i++) {
	echo '<hr width="80%"><p>';
	if (!empty($items[$i]['pubdate'])) {
		echo 'Date : ',clean_date($items[$i]['pubdate']),'<br />';
	}
	if (!empty($items[$i]['modified'])) {
		echo 'Modification : ',clean_date($items[$i]['modified']),'<br />';
	}
	if (!empty($items[$i]['author'])) {
		echo 'Auteur : ',clean_text($items[$i]['author'], $encode),'<br />';
	}
	if (!empty($items[$i]['category'])) {
		echo 'Catgorie : ',clean_text($items[$i]['category'], $encode),'<br />';
	}
	echo '<b>.:: <a href="',$items[$i]['link'],'" target="_blank">',clean_text($items[$i]['title'], $encode),'</a> ::.</b><br />',"\n";
	if (!empty($items[$i]['description'])) {
		echo clean_text($items[$i]['description'], $encode);
	}
	echo '</p>',"\n";
}

// formulaire si textinput existe
if($rss -> exist_textinput()) {
	$textinput = $rss -> get_textinput();
		echo '<form  method="get" action="',$textinput['link'],'">',
		$textinput['description'],'&nbsp;
		<input type="text" name="',$textinput['name'],
		'"size="10" maxlength="10">&nbsp;<input type="submit" name="Submit" 
		value="',$textinput['title'],'">
		</form>';
}	      

echo '</div>';
// ou si tableau
// echo '</td></tr></table>'

?>
</body>
</html>