<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
	<head>
		<meta http-equiv="content-type" content="text/html;charset=ISO-8859-1">
		<title>Exemple avec utilisation d'un cache</title>
		<style type="text/css" media="screen"><!--
.flux   { font-family: Verdana, Arial, Helvetica; background-color: #eee; margin-right: auto; margin-left: auto; padding: 3px; border-style: solid; border-width: 8px 1px 1px 1px; border-color: #ff8c00; width: 300px }
.flux p { font-weight: bold; font-size: 12px; background-color: #ffa530; text-align: center; margin-top: 0px }
.flux dt { font-size: 10px; line-height: 15px }
.flux dt a { color: black; text-decoration: none; padding-left: 5px }
.flux p a { color: navy; text-decoration: none }
.flux p a:hover, .flux dt a:hover { color: #de3400; text-decoration: underline overline }
--></style>
	</head>

	<body bgcolor="#ffffff">
	<p><b>Mettre en cache un flux en lecture</b></p>
		<p>Lorsqu'on syndique sur son site un flux rss d'une autre source, celle-ci pour des raisons diverses peut se trouver indisponible ou lente d'acc&egrave;s. Pour ne pas avoir &agrave; recalculer la page de votre site et &agrave; faire une requ&egrave;te sur le flux distant &agrave; chaque visite de celle-ci, il suffit d'en mettre tout ou partie en cache. Pour cela on g&eacute;n&eacute;re un fichier contenant le code html r&eacute;sultat de l'analyse du flux distant.</p>
		<p>Cette g&eacute;n&eacute;ration peut avoir lieu &agrave; intervalles de temps r&eacute;guliers (l'affichage sur votre site sera plus ou moins en retard sur le contenu du flux sur le site distant) l'intervalle de temps &eacute;tant d&eacute;fini en rapport avec l'activit&eacute; du flux syndiqu&eacute;. Autre solution possible si on peut obtenir la date de modification du flux distant, alors l'affichage sera synchrone avec le contenu du fichier. Dans ce dernier cas une requ&egrave;te (mais faisant transiter un volume restreint d'informations) est toujours n&eacute;cessaire. Le reste du temps on se contente d'inclure le code g&eacute;n&eacute;r&eacute; pr&eacute;c&eacute;demment.</p>
		<p>Le d&eacute;roulement des op&eacute;ration est en gros :</p>
		<p>Si (le fichier n'existe pas en cache ou il est insuffisament rescent) {<br>
				parser le flux distant;<br>
				g&eacute;n&eacute;rer le fichier en cache;<br>
			} // fin si<br>
				inclure le fichier en cache;</p>
		<p>Le fichier est-il en cache ? file_exists(string filename) permet de le savoir. Son &acirc;ge est donn&eacute; par filemtime(string filename) qui retoune la date de sa derni&egrave;re modification du cache sous forme d'un timestamp (nombre de secondes).</p>
		<p>Le flux est-il plus r&eacute;cent que le cache ? De deux choses l'une :<br>soit le serveur distant retourne l'information Last-Modified pour le fichier de flux, soit il ne la retourne pas. En effet les serveurs ne fournissent cette inforamation que pour les fichiers statiques, il ne la fournissent pas pour les fichiers dynamiques (php en particulier). Dans ce dernier cas, c'est au programmeur de mettre en place le m&eacute;canisme fournissant cette information (ce qui n'est pas toujours fait). Si la date de modification est fournie, on pourra alors s'en servir pour savoir si le flux est plus r&eacute;cent que le cache, sinon on se servira d'un d&eacute;lai fix&eacute; arbitrairement.</p>
		<p>Cette solution pr&eacute;sente le gros avantage de ne pas avoir &agrave; intervenir sur la configuration serveur (impossible pour un serveur mutualis&eacute;) ou &agrave; avoir recours &agrave; un serveur tiers d&eacute;clenchant la requ&egrave;te sur un fichier php design&eacute; sur votre site (solution du type cron.hiwit.org ou www.webcron.org). C'est la requ&egrave;te elle-m&ecirc;me sur la page qui d&eacute;clenche sa mise &agrave; jour ou non.</p>
		<p>Pour parser le flux distant la m&eacute;thode est la m&ecirc;me que celle d&eacute;crite dans le fichier exemple-1.php. Au lieu de faire des &eacute;chos successifs pour afficher le r&eacute;sultat de l'analyse, on stocke les chaines g&eacute;n&eacute;r&eacute;es dans une variable unique qui sera ensuite &eacute;crite dans un fichier plac&eacute; au bon endroit.</p>
		<p>On a alors le code suivant : voir le fichier &quot;parse_flux-1.php&quot;. Note : le code donn&eacute; dans ce fichier convient aussi bien pour les flux retournant la date de modification que pour ceux qui ne la donnent pas. On pourra bien s&ucirc;r adapter le script &agrave; un cas ou &agrave; l'autre.</p>
		<p>Dans le fichier o&ugrave; doit s'afficher le flux rss il suffira de faire une inclusion du fichier parse_flux-1.php &lt;?php include 'parse_flux-1.php'; ?&gt; (voir ce fichier ci-joint et prendre soin de cr&eacute;er un dossier &quot;cache&quot; ayant tous les droits en &eacute;criture - &agrave; adapter suivant h&eacute;bergeur -).</p>
		<p></p>
		<div class="flux">
<?php include 'parse_flux-1.php'; ?>
		</div>
		<p>La mise en forme est ici obtenue par une feuille de style avec une balise &quot;div&quot; de par et d'autre de l'instruction d'inclusion de parse_flux.php.</p>
		<p>&lt;div id=&quot;flux&quot;&gt;&lt;?php include 'parse_flux.php'; ?&gt;&lt;/div&gt;</p>
		<p>L'affichage ci dessus est obtenu avec la feuille de style suivante ;<br>
			&lt;style type=&quot;text/css&quot; media=&quot;screen&quot;&gt;&lt;!--<br>
			.flux { font-family: Verdana, Arial, Helvetica, sans-serif; background-color: #eee; margin-right: auto; margin-left: auto; padding: 3px; border-style: solid; border-width: 8px 1px 1px 1px; border-color: #ff8c00; width: 300px }<br>
			.flux dt { font-size: 10px; line-height: 15px }<br>
			.flux dt a { color: black; text-decoration: none; padding-left: 5px }<br>
			.flux p { font-weight: bold; font-size: 12px; background-color: #ffa530; text-align: center; margin-top: 0px }<br>
			.flux p a { color: navy; text-decoration: none }<br>
			.flux p a:hover, .flux dt a:hover { color: #de3400; text-decoration: underline overline }<br>
			--&gt;&lt;/style&gt;</p>
	</body>

</html>